// C Source File
// Created 09.01.2004; 16:00:46

#include <default.h>
#define UNOFFICIAL_OS_SUPPORT

#include <tigcclib.h>
//#include <extgraph.h>
#define OSdequeue _rom_call(short,(__pushort,void*),3AA)

//****************************************************************************

#ifndef __GRAY3P
#include "gray3P.h"
#endif

#include "gfxkk.h"
#include "font5.h"
#include "FS.h"

//****************************************************************************

#define MAX_X LCD_WIDTH
#define MAX_Y LCD_HEIGHT

#define PI2 (6.283185307) 
#define PIH (1.570796327) 

#define PI_K 314 
#define PI2_K 628
#define PIH_K 157
#define PI12_K 26

#define MAP_SIZEH 125
#define MAP_SIZE 250
#define MAP_SIZE1 249
#define MAP_SIZE100 25000
#define MAP_SIZE2 62500
#define F 5

#define RAY_DEPTH 40
#define RAY_DEPTHH 20
#define RAY_DEPTHQ 10

const unsigned char bit_table[8]={0x80,0x40,0x20,0x10,0x8,0x4,0x2,0x1};

//****************************************************************************

struct point3d_i_type
{
	long x, y, z;
};

//****************************************************************************

unsigned short i, j, k, m, n, u, v;
short					 is, js, ks, x, y, z, xo, yo, zo, xs, ys, zs, xn, yn, zn, s, t;
short					 cam_rot_x, cam_rot_x_fix, cam_rot_y, cam_rot_z, rot_x, rot_y, cam_speed;
short					 map_buf, map_buf_fin, details, yaw, gr_layer, interlace;
long					 l, w;
float					 f;
unsigned short ch, pos, pos2, pos3;
unsigned char  b, txt[80], sky_p[40];
unsigned char  RLE_buffer[(160*100)/8+3], win_x1, win_y1, win_x2, win_y2;
unsigned short *ray_map_ofs_p;
unsigned char  *map_data_p, *map_txtdata_p, *ray_map_x_p;
unsigned char  *lightp_p, *mediump_p, *darkp_p;
unsigned char  *ptr;
SCR_RECT			 full_screen = {{0, 0, 159, 99}};
BOOL					 q_7or8grays, q_haze, q_redraw, q_hud, q_small, q_full;

struct point3d_i_type movement;
struct point3d_i_type cam;

//****************************************************************************
//****************************************************************************
//****************************************************************************

void error (short err)
{
	GKeyFlush();
  if (Gray3PCheckRunning()) Gray3POff ();
  clrscr();
 	FontSetSys (F_6x8);
	if (err == 1)
	{ sprintf (txt, "There isn't enough"); DrawStr (0, 0 *9, txt, A_NORMAL);
		sprintf (txt, "free RAM!"); DrawStr (0, 1 *9, txt, A_NORMAL);
		sprintf (txt, "Please archive all"); DrawStr (0, 2 *9, txt, A_NORMAL);
		sprintf (txt, "files inclusive maps."); DrawStr (0, 3 *9, txt, A_NORMAL);
		sprintf (txt, "Trying to recover system"); DrawStr (0, 5 *9, txt, A_NORMAL);
		sprintf (txt, "when ready... [Key]"); DrawStr (0, 6 *9, txt, A_NORMAL);
	}
	if (err == 3)
	{ sprintf (txt, "Missing map files!"); DrawStr (0, 0 *9, txt, A_NORMAL);
		sprintf (txt, "Use VX.Studio to create"); DrawStr (0, 1 *9, txt, A_NORMAL);
		sprintf (txt, "a new random map."); DrawStr (0, 2 *9, txt, A_NORMAL);
		sprintf (txt, "Trying to recover system"); DrawStr (0, 4 *9, txt, A_NORMAL);
		sprintf (txt, "when ready... [Key]"); DrawStr (0, 5 *9, txt, A_NORMAL);
	}
 	FontSetSys (F_4x6);
	sprintf (txt, "In case your calc crashes now, you have"); DrawStr (0, 100- 5 *6, txt, A_NORMAL);
	sprintf (txt, "two chances to save the Archive Mem. Try to"); DrawStr (0, 100- 4 *6, txt, A_NORMAL);
	sprintf (txt, "hold [2nd]+[<-]+[->]+[ON], or otherwise hold"); DrawStr (0, 100- 3 *6, txt, A_NORMAL);
	sprintf (txt, "[ON] and remove for a second all batteries."); DrawStr (0, 100- 2 *6, txt, A_NORMAL);
	sprintf (txt, "The calc should only reset the RAM now."); DrawStr (0, 100- 1 *6, txt, A_NORMAL);
	ngetchx();
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void clrscr_gr (short delay)
{
	long l;
 	if ((delay == 1) || (delay == 3)) for (l=0; l<75000; l++);
	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
	if (delay < 2) ClrScr ();
	else ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
 	if ((delay == 1) || (delay == 3)) for (l=0; l<75000; l++);
	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
	if (delay < 2) ClrScr ();
	else ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
 	if ((delay == 1) || (delay == 3)) for (l=0; l<75000; l++);
  Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	if (delay < 2) ClrScr ();
	else ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

short calibration_scr (void)
{
q_7or8grays =TRUE;
if (!Gray3POn (q_7or8grays)) return (1);
/*
ch = KEY_F1;
while ((ch == KEY_F1) || (ch == KEY_F2))
{
 	clrscr_gr (2);
	for (gr_layer = 0; gr_layer < 3; gr_layer++)
	{	if (gr_layer == 0) Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
		if (gr_layer == 1) Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
		if (gr_layer == 2) Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
		
		ScrRectFill (&(SCR_RECT){{0, 0, 159, 8}}, &full_screen , A_REVERSE); 
	 	FontSetSys (F_6x8);
		sprintf (txt, "Display Calibration"); DrawStr (22, 1, txt, A_XOR);
	 	FontSetSys (F_4x6);
		sprintf (txt, "Test & choose the better grayscale mode:"); DrawStr (0, 2 *6 +3, txt, A_REVERSE);
		sprintf (txt, "[F1]   8 grays, better for real calcs (default)"); DrawStr (0, 3 *6 +6, txt, A_REVERSE);
		sprintf (txt, "[F2]   7 grays, use it on VTI emulator"); DrawStr (0, 4 *6 +7, txt, A_REVERSE);
		sprintf (txt, "Set the brightness level to a state so that"); DrawStr (0, 5 *6 +10, txt, A_REVERSE);
		sprintf (txt, "you can still differ the darkest 2 gray levels."); DrawStr (0, 6 *6 +10, txt, A_REVERSE);
	}
	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){{1 *20, 80, 2 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=1*20; i<2*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){{2 *20, 80, 3 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=2*20; i<3*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){{3 *20, 80, 4 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=3*20; i<4*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){{3 *20, 80, 4 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=3*20; i<4*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){{4 *20, 80, 5 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=4*20; i<5*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){{5 *20, 80, 6 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=5*20; i<6*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){{5 *20, 80, 6 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=5*20; i<6*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){{6 *20, 80, 7 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=6*20; i<7*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){{6 *20, 80, 7 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=6*20; i<7*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); ScrRectFill (&(SCR_RECT){{7 *20, 80, 8 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=7*20; i<8*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); ScrRectFill (&(SCR_RECT){{7 *20, 80, 8 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=7*20; i<8*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); ScrRectFill (&(SCR_RECT){{7 *20, 80, 8 *20 -1, 99}}, &full_screen , A_REVERSE); for (i=7*20; i<8*20; i+=2) DrawLine (i,60,i,79, A_REVERSE);

	ch = ngetchx();
	if (ch == KEY_F1) { q_7or8grays = TRUE; if (Gray3PCheckRunning()) Gray3POff (); Gray3POn (q_7or8grays); }
	if (ch == KEY_F2) { q_7or8grays = FALSE; if (Gray3PCheckRunning()) Gray3POff (); Gray3POn (q_7or8grays); }
	if (ch == KEY_ESC) return (1);
}*/
return (0);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

/* Decompresses an image that has been compressed with horizontal RLE
 */
#define SENTINEL_VALUE 0x91

void DecompRLEHor(unsigned char *src, unsigned char *dest, short size)
{
	int pos = 0;
	int dcmpNum = 0;
	int i=0,j;

	while (dcmpNum < size)
	{
		//decompress a run
		if (src[i] == SENTINEL_VALUE)
		{
			i++;
			for(j = 0; j < src[i + 1]; j++)
				dest[pos++] = src[i];
			i++;
			dcmpNum += src[i];
		}
		else
		{
			dest[pos++] = src[i];
			dcmpNum++;			
		}
		i++;
	}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void check_keys (void)
{
//		void *kbq = kbd_queue ();
//		if (!OSdequeue (&ch, kbq))
		if (kbhit())
		{
			ch = ngetchx();
			if (ch >= 0x800) ch -= 0x800;

//			if (ch == '+') if (details<5) details++; 
//			if (ch == '-') if (details>1) details--; 
		
			if (ch == KEY_LEFT || ch == 339 || ch == 342) 
														{ if (cam_rot_z > -14) cam_rot_z -= 7; }
		 	if (ch == KEY_RIGHT || ch == 345 || ch == 348) 	
														{ if (cam_rot_z < 14) cam_rot_z += 7; }
		 	if (ch == KEY_UP || ch == 339 || ch == 345) 
														{ if (cam_rot_y > -15) cam_rot_y -= 5; }
		 	if (ch == KEY_DOWN || ch == 342 || ch == 348)
														{ if (cam_rot_y < 15) cam_rot_y += 5; }
			if (TI89 && ch == KEY_BACKSPACE || TI92PLUS && ch == 261 || ch == 149)
		 									  		{ if (cam_rot_x > -500) cam_rot_x -= 50; }
			if (TI89 && ch == KEY_CLEAR || TI92PLUS && ch == 94) 	{ if (cam_rot_x < 500) cam_rot_x += 50; }
			if (TI89 && ch == 94 || TI92PLUS && ch == 260) { if (cam.z <= 40000) movement.z += 200; }
			if (TI89 && ch == 116 || TI92PLUS && ch == 259) { if (cam.z <= 40000) movement.z -= 200; }
			
			if (ch == 265)
			{ show_map();
				ngetchx();
				q_redraw = TRUE;
			}
			if (ch == KEY_SIGN) { q_haze = !q_haze; q_redraw = TRUE; }
			if (ch == KEY_MODE) { q_hud = !q_hud; q_redraw = TRUE; }
			if (ch == '.') { q_small = !q_small; q_redraw = TRUE; }
			if (ch == '/') { q_full = !q_full; q_redraw = TRUE; }
		}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void calc_vehicle (void)
{
		if (cam_rot_y != 0) cam_rot_x_fix += cam_rot_z *5;
		cam_rot_x_fix += cam_rot_x;

		l = RAY_DEPTH *40 *4;
		if (cam_rot_x_fix >= l) cam_rot_x_fix -= l;
		if (cam_rot_x_fix < 0) cam_rot_x_fix += l;
		
		f = cam_rot_x_fix /((RAY_DEPTH *40) /PIH);
		movement.x -= (sin ((float) f) *cam_rot_y);
		movement.y += (cos ((float) f) *cam_rot_y);
		
		movement.x -= (sin ((float) f -PIH) *cam_rot_z);
		movement.y += (cos ((float) f -PIH) *cam_rot_z);
				
		if (movement.x < -500) movement.x = -500; if (movement.x > 500) movement.x = 500; 
		if (movement.y < -500) movement.y = -500; if (movement.y > 500) movement.y = 500; 
		if (movement.z < -1000) movement.z = -1000; if (movement.z > 1000) movement.z = 1000; 
	
		cam.x += movement.x; 	 	  
		if (cam.x < 0) cam.x += MAP_SIZE100; if (cam.x >= MAP_SIZE100) cam.x -= MAP_SIZE100;
		cam.y += movement.y;
		if (cam.y < 0) cam.y += MAP_SIZE100; if (cam.y >= MAP_SIZE100) cam.y -= MAP_SIZE100;
		cam.z += movement.z -((map_data_p[pos2] +20) *100);
		if (cam.z < 0) { cam.z = 0; movement.z = 0; }
		cam.z += (map_data_p[pos2] +20) *100;
		if (cam.z > 40000) { /*cam.z = 40000;*/ movement.z = movement.z -50; }

		cam_rot_x = cam_rot_x *9 /10;
		cam_rot_y = cam_rot_y *9 /10;
		cam_rot_z = cam_rot_z *9 /10;
		movement.x = (long) movement.x *39 /40;
		movement.y = (long) movement.y *39 /40;
		movement.z = (long) movement.z *39 /40;
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void show_map (void)
{
	clrscr_gr (3);

	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	FontSetSys (F_6x8);
	sprintf (txt, "Map:", (float) MAP_SIZE*MAP_SIZE);
	DrawStr (38, 1, txt, A_REVERSE);

	for (j = 0; j < MAP_SIZE; j += 3)
		for (i = 0; i < MAP_SIZE; i += 3)
  	{
			xs = i /3 +39; ys = j /3 +12;

			if (i %2 == 0) u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0xf0);
			else 					 u = (map_txtdata_p[(i/2)+(j)*MAP_SIZEH] & 0x0f) *16;
	
 			if (u < 128) 		 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (xs, ys, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_DARK_PLANE); DrawPix (xs, ys, A_REVERSE); }
			if (u %128 < 64) { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (xs, ys, A_NORMAL); }
			else 						 { Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE); DrawPix (xs, ys, A_REVERSE); }
   		if (u %64 < 32)	 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (xs, ys, A_NORMAL); }
  		else 						 { Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE); DrawPix (xs, ys, A_REVERSE); }
		}
	i = (cam.x /100) /3 +39; j = (cam.y /100) /3 +12;
	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	DrawLine (i, 11, i, 96, A_REVERSE);
	DrawLine (38, j, 123, j, A_REVERSE);
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void generate_shadows (short quite)
{
	if (quite > 0) 
	{
		Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
		sprintf (txt, "Generating shadow maps...  ");
		DrawStr (0, 1, txt, A_REVERSE);
	}

	for (j = 0; j < MAP_SIZE; j += 1)
	{
		k = 0;
		for (i = 0; i < MAP_SIZE; i += 1)
  	{
			if (i < MAP_SIZE)
				v = map_data_p[(i)+(j)*MAP_SIZE];
			else v = 0;
			if (i > 0)
			{	if ((i-1) %2 == 0) u = (map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] & 0xf0);
				else 							 u = (map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] & 0x0f) *16;
			}
			else u = 0;

			if (v > k) k = v;
 			z = k -3; if (z < 0) z = 0;
 			if (v <= z) if (u >= 64) u -= 32;
 			z = k -8; if (z < 0) z = 0;
 		  if (v <= z) if (u >= 64) u -= 32;
		  
			if (i > 0)
			if ((i-1) %2 == 0) map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] = (map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] & 0x0f) | (0xf0 & ((u /16) *16));
			else 							 map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] = (map_txtdata_p[((i-1)/2)+(j)*MAP_SIZEH] & 0xf0) | (0x0f & (u /16));	
	
			if (k >= 3) k -= 3;
		}			
		if (quite == 0)
		{
		  ScrRectFill (&(SCR_RECT){{0, 91, j *160 /MAP_SIZE, 99}}, &full_screen , A_REVERSE); 
			ScrRectFill (&(SCR_RECT){{j *160 /MAP_SIZE +1, 91, 159, 99}}, &full_screen , A_NORMAL); 
			sprintf (txt, "Working... %d%%", j *100 /MAP_SIZE+1);
			FS_DrawMonoString (38, 92, txt, A_XOR, F_6x8);
		}
	}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

void generate_rays (void)
{
	for (is=0, k=0; (is < 40); is++) // screen width
  {
 		for (js=0; (js < RAY_DEPTH); js++, k++) // depth
  	{
			// if js == RAY_DEPTH then y == 80
			y = js;
			if (js > 30) y = (pow (js -22, 4) /2000) +28;

			x = is -20;	
			y = (40 -(x *x) /40 -(x *x *x *x) /40000) *y /40;
			x = x *(RAY_DEPTH /20) *y /40;

			l = (+x) +(-y) *MAP_SIZE; if (l < 0) l = MAP_SIZE2 +l;
			ray_map_ofs_p[k] 									 = l; 	 	  
			l = (+y) +(+x) *MAP_SIZE; if (l < 0) l = MAP_SIZE2 +l;
			ray_map_ofs_p[k +(40 *RAY_DEPTH)]  = l; 	 	  
			l = (-x) +(+y) *MAP_SIZE; if (l < 0) l = MAP_SIZE2 +l;
			ray_map_ofs_p[k +(80 *RAY_DEPTH)]  = l; 	 	  
			l = (-y) +(-x) *MAP_SIZE; if (l < 0) l = MAP_SIZE2 +l;
			ray_map_ofs_p[k +(120 *RAY_DEPTH)] = l; 	 	  
			l = (+x) +(-y) *MAP_SIZE; if (l < 0) l = MAP_SIZE2 +l;
			ray_map_ofs_p[k +(160 *RAY_DEPTH)] = l; 	 	  
	
			ray_map_x_p[k] 						= is *4;
   		ray_map_x_p[k +(40 *RAY_DEPTH)] 	= is *4 +160;
   		ray_map_x_p[k +(80 *RAY_DEPTH)] 	= is *4 +320;
   		ray_map_x_p[k +(120 *RAY_DEPTH)] = is *4 +480;
   		ray_map_x_p[k +(160 *RAY_DEPTH)] = is *4 +640;
   	}
  	ScrRectFill (&(SCR_RECT){{0, 91, (is +1) *4, 99}}, &full_screen , A_REVERSE); 
		ScrRectFill (&(SCR_RECT){{(is +1) *4 +1, 91, 159, 99}}, &full_screen , A_NORMAL); 
		sprintf (txt, "Working... %d%%", (is +1) *40 /16);
		FS_DrawMonoString (38, 92, txt, A_XOR, F_6x8);
	}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

short load_map (short which)
{
FILE *fp;
unsigned short size;
unsigned char btimes;

if (which == 1)
{
if (!(fp=fopen("maph","rb"))) return (1);
#define NAME map_data_p
size = MAP_SIZE*MAP_SIZE;
fseek (fp, 40, SEEK_SET);
//	fread (NAME, 1, size,fp); //uncompressed
	k = size /160;
	for (i = 0; i < size; i++) //compressed
	{
		btimes = 0;
		b = fgetc (fp);
		if (b == 0)
		{
			btimes = fgetc (fp);
			b = fgetc (fp);
			for (j = i; j < i +1 +btimes; j++)
				NAME[j] = b;
		}
		else NAME[i] = b;
		i += btimes;

	  if (i %k == 0)
		{	ScrRectFill (&(SCR_RECT){{0, 91, i /(size /160), 99}}, &full_screen , A_REVERSE); 
			ScrRectFill (&(SCR_RECT){{i /(size /160) +1, 91, 159, 99}}, &full_screen , A_NORMAL); 
			sprintf (txt, "Working... %d%%", i /((size-1) /100));
			FS_DrawMonoString(38, 92, txt, A_XOR, F_6x8);
		}
	}
fclose(fp);
}

if (which == 2)
{
if (!(fp=fopen("mapt","rb"))) return (1);
#define NAME map_txtdata_p
size = MAP_SIZE*MAP_SIZEH;
fseek (fp, 40, SEEK_SET);
//	fread (NAME, 1, size,fp); //uncompressed
	k = size /160;
	for (i = 0; i < size; i++) //compressed
	{
		btimes = 0;
		b = fgetc (fp);
		if (b == 0)
		{
			btimes = fgetc (fp);
			b = fgetc (fp);
			for (j = i; j < i +1 +btimes; j++)
				NAME[j] = b;
		}
		else NAME[i] = b;
		i += btimes;

	  if (i %k == 0)
		{	ScrRectFill (&(SCR_RECT){{0, 91, i /(size /160), 99}}, &full_screen , A_REVERSE); 
			ScrRectFill (&(SCR_RECT){{i /(size /160) +1, 91, 159, 99}}, &full_screen , A_NORMAL); 
			sprintf (txt, "Working... %d%%", i /((size-1) /100));
			FS_DrawMonoString(38, 92, txt, A_XOR, F_6x8);
		}
	}
fclose(fp);
}
}

//****************************************************************************
//****************************************************************************
//****************************************************************************

// Main Function
void _main(void)
{
	clrscr();
	SetupCharSet();
	OSInitKeyInitDelay (96); OSInitBetweenKeyDelay (4);
	if (calibration_scr() == 1) goto quit;
	
	clrscr_gr (3);
  if (Gray3PCheckRunning()) Gray3POff ();
	clrscr();

	ScrRectFill (&(SCR_RECT){{0, 0, 159, 99}}, &full_screen , A_NORMAL); 
	ScrRectFill (&(SCR_RECT){{0, 0, 159, 8}}, &full_screen , A_REVERSE); 
			
	FontSetSys (F_6x8); sprintf (txt, "VOXELSPACE-Engine V2"); DrawStr (16, 1, txt, A_XOR);
	FontSetSys (F_4x6);	sprintf (txt, "Realtime Game Demo v1.5"); DrawStr (35, 11, txt, A_REVERSE);
	FontSetSys (F_4x6);	sprintf (txt, "Copyright (C) 2004, 2006 by Kai Kostack"); DrawStr (10, 18, txt, A_REVERSE);
	FontSetSys (F_4x6);	sprintf (txt, "www.KaiKostack.com"); DrawStr (41, 25, txt, A_REVERSE);
  
	s = 7; t = 40;
	FontSetSys (F_4x6);	sprintf (txt, "Allocating memory..."); DrawStr (0, t, txt, A_REVERSE);
  if (!(map_data_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *MAP_SIZE*MAP_SIZE)))
	{ error (1); goto quit; }
  if (!(map_txtdata_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *MAP_SIZE*MAP_SIZEH)))
	{ error (1); goto quit; }
	if (!(ray_map_ofs_p = (unsigned short *) malloc ((unsigned short) sizeof(short) *RAY_DEPTH *40 *5)))
	{ error (1); goto quit; }
	if (!(ray_map_x_p = (unsigned char *) malloc ((unsigned short) sizeof(char) *RAY_DEPTH *40 *5)))
	{ error (1); goto quit; }
	FontSetSys (F_4x6);	sprintf (txt, "Allocating memory... Done."); DrawStr (0, t, txt, A_REVERSE);
  t += s;
  
	FontSetSys (F_4x6);	sprintf (txt, "Precalculating memory offsets..."); DrawStr (0, t, txt, A_REVERSE);
	generate_rays();
	FontSetSys (F_4x6);	sprintf (txt, "Precalculating memory offsets... Done."); DrawStr (0, t, txt, A_REVERSE);
  t += s;
	
	FontSetSys (F_4x6);	sprintf (txt, "Loading terrain heights..."); DrawStr (0, t, txt, A_REVERSE);
	if (load_map(1) == 1) { error (3); goto quit; }
	FontSetSys (F_4x6);	sprintf (txt, "Loading terrain heights... Done."); DrawStr (0, t, txt, A_REVERSE);
  t += s;
	
	FontSetSys (F_4x6);	sprintf (txt, "Loading texture map..."); DrawStr (0, t, txt, A_REVERSE);
	if (load_map(2) == 1) { error (3); goto quit; }
	FontSetSys (F_4x6);	sprintf (txt, "Loading texture map... Done."); DrawStr (0, t, txt, A_REVERSE);
  t += s;
	
	FontSetSys (F_4x6);	sprintf (txt, "Calculating shadow map..."); DrawStr (0, t, txt, A_REVERSE);
	generate_shadows (0);
	FontSetSys (F_4x6);	sprintf (txt, "Calculating shadow map... Done."); DrawStr (0, t, txt, A_REVERSE);
  t += s;

	FontSetSys (F_4x6);	sprintf (txt, "Initializing engine..."); DrawStr (0, t, txt, A_REVERSE);

	for (l=0; l<150000; l++); // wait
	
	GKeyFlush();

//****************************************************************************
	
	Gray3POn (q_7or8grays);

  for (l=0; l<75000; l++); Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	DecompRLEHor(&gfx_kk_1, &RLE_buffer, sizeof (RLE_buffer));
 	BitmapPut(0, 0, &RLE_buffer, &full_screen, A_REPLACE);
	for (l=0; l<75000; l++); Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
	DecompRLEHor(&gfx_kk_2, &RLE_buffer, sizeof (RLE_buffer));
 	BitmapPut(0, 0, &RLE_buffer, &full_screen, A_REPLACE);
	for (l=0; l<75000; l++); Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
	DecompRLEHor(&gfx_kk_3, &RLE_buffer, sizeof (RLE_buffer));
 	BitmapPut(0, 0, &RLE_buffer, &full_screen, A_REPLACE);

	for (l=0; l<500000; l++); // wait
	clrscr_gr (3);
 	
  for (l=0; l<75000; l++); Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	DecompRLEHor(&gfx_v2_1, &RLE_buffer, sizeof (RLE_buffer));
 	BitmapPut(0, 0, &RLE_buffer, &full_screen, A_REPLACE);
	for (l=0; l<75000; l++); Gray3PSetAMSPlane (GRAY3P_MEDIUM_PLANE);
	DecompRLEHor(&gfx_v2_2, &RLE_buffer, sizeof (RLE_buffer));
 	BitmapPut(0, 0, &RLE_buffer, &full_screen, A_REPLACE);
	for (l=0; l<75000; l++); Gray3PSetAMSPlane (GRAY3P_LIGHT_PLANE);
	DecompRLEHor(&gfx_v2_3, &RLE_buffer, sizeof (RLE_buffer));
 	BitmapPut(0, 0, &RLE_buffer, &full_screen, A_REPLACE);
 	
	for (l=0; l<500000; l++); // wait
	clrscr_gr (3);
	for (l=0; l<75000; l++);
	
	if (kbhit()) GKeyFlush();

//****************************************************************************

	cam.x = 125 *100;
	cam.y = 125 *100; 	 	  
		xn = cam.x /100; yn = cam.y /100;	pos2 = (xn) +(yn) *MAP_SIZE;
	cam.z = (map_data_p[pos2] +32) *100;
	cam_speed = 0; // 100 = voxel / frame
 	cam_rot_x_fix = 0 *RAY_DEPTH; // 40 *RAY_DEPTH = 90
	cam_rot_x = 0; // 0 = center
	cam_rot_y = 0; // 0 = center
	cam_rot_z = 0; // 0 = horizontal

//****************************************************************************
	
	details = 1;
	q_haze = TRUE;
	q_hud = TRUE;
	q_small = FALSE;
	q_full = FALSE;
	
	for (i = 0; i < 40; i++) sky_p[i] = 0;
	interlace = 0;
	q_redraw = TRUE;

	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
	
	lightp_p = (unsigned char *) Gray3PGetPlane (GRAY3P_LIGHT_PLANE);
	mediump_p = (unsigned char *) Gray3PGetPlane (GRAY3P_MEDIUM_PLANE);
	darkp_p = (unsigned char *) Gray3PGetPlane (GRAY3P_DARK_PLANE);

	ch = 1;
	OSFastArrows = 0;
	while (ch != KEY_ESC)
	{
		if (q_redraw)
		{ 
		  clrscr_gr (2);
	
			if (!q_full)
			{
				sprintf (txt, "UP DOWN LEFT RIGHT - Pitch, Roll");
				FS_DrawGrayString (3, 97-6*4, txt, A_XOR, F_4x6);
				if (TI89) sprintf (txt,     "[T] [^] - Collective   APPS - Map   [/] - Full");
				if (TI92PLUS) sprintf (txt, "SIN COS - Collective   APPS - Map   [/] - Full");
				FS_DrawGrayString (3, 97-6*3, txt, A_XOR, F_4x6);
			
				if (TI89) if (q_hud) sprintf (txt, "BACKSPACE CLEAR - Fantail   MODE - HUD: ON  ");
				else sprintf (txt, "BACKSPACE CLEAR - Fantail   MODE - HUD: OFF ");
				if (TI92PLUS) if (q_hud) sprintf (txt, "TAN [^] - Fantail   MODE - HUD: ON  ");
				else sprintf (txt, "TAN [^] - Fantail   MODE - HUD: OFF ");
				FS_DrawGrayString (3, 97-6*2, txt, A_XOR, F_4x6);
				if (q_haze && q_small) { sprintf (txt, "[(-)] - Haze: ON   [.] - Small window: ON  ");
				FS_DrawGrayString (3, 97-6*1, txt, A_XOR, F_4x6); }
				if (!q_haze && q_small) { sprintf (txt, "[(-)] - Haze: OFF   [.] - Small window: ON  ");
				FS_DrawGrayString (3, 97-6*1, txt, A_XOR, F_4x6); }
				if (q_haze && !q_small) { sprintf (txt, "[(-)] - Haze: ON   [.] - Small window: OFF  ");
				FS_DrawGrayString (3, 97-6*1, txt, A_XOR, F_4x6); }
				if (!q_haze && !q_small) { sprintf (txt, "[(-)] - Haze: OFF   [.] - Small window: OFF  ");
				FS_DrawGrayString (3, 97-6*1, txt, A_XOR, F_4x6); }
			}
			q_redraw = FALSE;
		}

		calc_vehicle();

		xn = cam.x /100;
		yn = cam.y /100;
		zn = cam.z /100;
		pos2 = (xn) +(yn) *MAP_SIZE;
		
		rot_x = (cam_rot_x_fix /RAY_DEPTH) *RAY_DEPTH;
		rot_y = cam_rot_y +30;
	
		if (!q_small)
		{ win_x1 = 1; win_x2 = 39; win_y1 = 3; if (!q_full) win_y2 = 67; else win_y2 = 95; }
		else
		{ win_x1 = 8; win_x2 = 32; win_y1 = 3; if (!q_full) win_y2 = 67; else win_y2 = 95; }
	 	ks = win_x2 *RAY_DEPTH +rot_x;
		xs = -1;
		for (k = win_x1 *RAY_DEPTH +rot_x; k < ks; k = m)
 		{ 
			xs = ray_map_x_p[k -rot_x];
			yaw =	((20 -(xs /4)) *cam_rot_z) /20;
		
			ys = win_y2;
			
			for (m = k +RAY_DEPTH, b = 1; k < m; k += details, b += details)
 			{
				l = (long) ray_map_ofs_p[k] +pos2;
				if (l >= MAP_SIZE2) pos = l - MAP_SIZE2; else pos = l;
				
				yo = ys;
   			ys = rot_y +((zn -map_data_p[pos]) *10) /b +yaw;
				
				if (ys < win_y1) ys = win_y1;
				
				if (ys < yo)
				{
						if (pos %2 == 0) u = (map_txtdata_p[pos /2] & 0xf0);
						else 					 	 u = (map_txtdata_p[pos /2] & 0x0f) *16;
				
						if (q_haze)
						{
							n = RAY_DEPTH - (k %RAY_DEPTH);
							if (n < RAY_DEPTHQ) u = (u *n /RAY_DEPTHQ) +(239 *(RAY_DEPTHQ -n) /RAY_DEPTHQ);
						}
						
						xn = (xs /8);
						
						if (xs %8 >= 4)
						{
							for (i = 0, j = yo -ys -1; (i <= j); i++)
							{
								pos3 = xn +(yo -i) *30;
								
 								if (u < 128) 		 darkp_p[pos3] |= 0x0f;	 
								else 						 darkp_p[pos3] &= 0xf0;
								if (u %128 < 64) mediump_p[pos3] |= 0x0f;	
								else 						 mediump_p[pos3] &= 0xf0;
								if (u %64 < 32)	 lightp_p[pos3] |= 0x0f;	
								else 						 lightp_p[pos3] &= 0xf0;
							}
						}
						else
						{
							for (i = 0, j = yo -ys -1; (i <= j); i++)
							{
								pos3 = xn +(yo -i) *30;
 		  					
 								if (u < 128) 		 darkp_p[pos3] |= 0xf0;	 
								else 						 darkp_p[pos3] &= 0x0f;
								if (u %128 < 64) mediump_p[pos3] |= 0xf0;	
								else 						 mediump_p[pos3] &= 0x0f;
								if (u %64 < 32)	 lightp_p[pos3] |= 0xf0;	
								else 						 lightp_p[pos3] &= 0x0f;
							}
						}
					if (ys == win_y1) k = m;
				}
				else ys = yo;
			}

/*	
			{
				pos3 = (xs /8) +((ys +1) *30);
				n = xs /4;
				j = ys -win_y1;
				
				if (j > sky_p[n])
				{
					u =	j;
					j -= sky_p[n];
					if (xs %8 >= 4)
					for (i = 0; (i < j); i++)
					{	pos3 -= 30;
						darkp_p[pos3] &= 0xf0; mediump_p[pos3] &= 0xf0; lightp_p[pos3] &= 0xf0;
					}
					else
					for (i = 0; (i < j); i++)
					{ pos3 -= 30;
						darkp_p[pos3] &= 0x0f; mediump_p[pos3] &= 0x0f; lightp_p[pos3] &= 0x0f;
					}
					sky_p[n] = u;
				}
				else sky_p[n] = j;
			}
*/
			{
				pos3 = (xs /8) +((ys +1) *30);
				j = ys -win_y1;
			
					if (xs %8 >= 4)
					for (i = 0; (i < j); i++)
					{	pos3 -= 30;
						darkp_p[pos3] &= 0xf0; mediump_p[pos3] &= 0xf0; lightp_p[pos3] &= 0xf0;
					}
					else
					for (i = 0; (i < j); i++)
					{ pos3 -= 30;
						darkp_p[pos3] &= 0x0f; mediump_p[pos3] &= 0x0f; lightp_p[pos3] &= 0x0f;
					}
			}

			if (q_hud)
			{	Gray3PSetAMSPlane (GRAY3P_DARK_PLANE);
				
				if ((xs	>= 56) && (xs < 108) && (xs %8 == 0))
				{	ys = rot_y +(((20 -(xs /4)) *cam_rot_z) /20);
					yo = rot_y +(((20 -((xs+3) /4)) *cam_rot_z) /20);
					xo = xs -2;
					if ((ys >= 4) && (ys <= 67)) DrawLine (xo, ys, xo +3, yo, A_XOR);
				}
				
				if (xs == 40)
				{ s = sqrt ((((float) movement.x *movement.x) +(movement.y *movement.y) +(movement.z *movement.z) /4)) /2;
					if (s > 999) s = 999;
					sprintf (txt, "%03d", s); FS_DrawGrayString (32, 28, txt, A_XOR, F_4x6);
				}
				if (xs == 124)
				{	s = (cam.z /100) -map_data_p[pos2];
					if (s > 999) s = 999;
					sprintf (txt, "%03d", s); FS_DrawGrayString (115, 28, txt, A_XOR, F_4x6);
				}
				if (xs == 88)
				{	s = ((rot_x /RAY_DEPTH) *90) /RAY_DEPTH;
					if (s > 999) s = 999;
					sprintf (txt, "%03d", s); FS_DrawGrayString (74, 8, txt, A_XOR, F_4x6);
					DrawLine (70, 8, 70, 12, A_XOR);
					DrawLine (90, 8, 90, 12, A_XOR);
				}
			if (!q_small)
			{
				if (xs == 28)
				{	s = sqrt ((((float) movement.x *movement.x) +(movement.y *movement.y) +(movement.z *movement.z) /4)) /2;
					if (s > 999) s = 999;
					for (i = 10; i <= 58; i++)
					{
						t = i -s; u = s -i +30;
						if (t <= 30 && t %10 == 0) DrawLine (26, i, 29, i, A_XOR);
						if (t <= 30 && (t-5) %10 == 0) DrawPix (26, i, A_XOR);
						if (t <= 30 && u %20 == 0) { sprintf (txt, "%3d", u); DrawStr_font5 (12, i -2, txt, A_XOR); }
					}
				}
				if (xs == 148)
				{	s = (cam.z /100) -map_data_p[pos2];
					if (s > 999) s = 999;
					for (i = 10; i <= 58; i++)
					{
						t = i -(s *2 /5); u = (s *2 /5) -i +30;
						if (t <= 30 && (t-10) %20 == 0) DrawLine (130, i, 133, i, A_XOR);
						if (t <= 30 && t %20 == 0) DrawPix (133, i, A_XOR);
						if (t <= 30 && u %20 == 0) { sprintf (txt, "%d", u *5 /2); DrawStr_font5 (137, i -2, txt, A_XOR); }
					}
				}	
			}
				if (xs == 76)
				{	DrawLine (70, 20, 75, 25, A_XOR);
					DrawLine (70, 40, 75, 35, A_XOR);
				}
/*			if (xs == 80)
				{	DrawLine (80, 10, 80, 15, A_XOR);
					DrawLine (80, 45, 80, 50, A_XOR);
				}
*/			if (xs == 92)
				{	DrawLine (89, 20, 84, 25, A_XOR);
					DrawLine (89, 40, 84, 35, A_XOR);
				}
				if (xs == 52)
					DrawLine (46, 34, 50, 30, A_XOR);
				if (xs == 116)
					DrawLine (109, 30, 113, 34, A_XOR);
			}
		}
		if (interlace == 0) interlace = 1; else interlace = 0;
		
		check_keys();
	}

	clrscr_gr (1);

 	quit:
  OSFastArrows = 0;
	OSInitKeyInitDelay (336); OSInitBetweenKeyDelay (48);
	if (map_data_p) free (map_data_p);
  if (map_txtdata_p) free (map_txtdata_p);
  if (ray_map_ofs_p) free (ray_map_ofs_p);
 	if (ray_map_x_p) free (ray_map_x_p);
  if (Gray3PCheckRunning()) Gray3POff ();
}
